package de.meinefirma.meinprojekt;

import java.util.Timer;
import javax.servlet.*;

public class GcCpuTxMBeanServletContextListener implements ServletContextListener
{
   private static final int MILLISEK_PRO_SEK    = 1000;
   private static final int MILLISEK_PRO_10_MIN = 1000 * 60 * 10;

   @Override
   public final void contextInitialized( ServletContextEvent servletContextEvent )
   {
      String loggerName = servletContextEvent.getServletContext().getInitParameter( "GcCpuTxLoggerName" );
      String logFile    = servletContextEvent.getServletContext().getInitParameter( "GcCpuTxLogFile" );
      String doGC       = servletContextEvent.getServletContext().getInitParameter( "GcCpuTxDoGC" );
      String periodSec  = servletContextEvent.getServletContext().getInitParameter( "GcCpuTxMeasurePeriodSec" );
      int periodMs;
      try {
         periodMs = MILLISEK_PRO_SEK * Math.max( 1, Integer.parseInt( periodSec ) );
      } catch( Exception ex ) {
         periodMs = MILLISEK_PRO_10_MIN;
      }
      GcCpuTxMBeanTimerTask mBeanTimerTask = new GcCpuTxMBeanTimerTask(
            loggerName, logFile, doGC == null || doGC.trim().equalsIgnoreCase( "true" ) );
      servletContextEvent.getServletContext().setAttribute( GcCpuTxMBeanTimerTask.class.getName(), mBeanTimerTask );
      (new Timer()).scheduleAtFixedRate( mBeanTimerTask, 0, periodMs );
   }

   @Override
   public final void contextDestroyed( ServletContextEvent servletContextEvent )
   {
      GcCpuTxMBeanTimerTask mbtt = (GcCpuTxMBeanTimerTask) servletContextEvent.getServletContext().getAttribute( GcCpuTxMBeanTimerTask.class.getName() );
      if( mbtt != null ) { mbtt.cancel(); }
   }
}
