import java.util.*;
import javax.naming.*;
import weblogic.jndi.Environment;
import weblogic.management.MBeanHome;
import weblogic.management.runtime.*;

public class Weblogic8ServerRuntimeMBean
{
   public static void main( String[] args ) throws NamingException
   {
      String url = "t3://localhost:7001";
      String usr = "weblogic";
      String pwd = "weblogic0";
      Environment env = new Environment();
      env.setProviderUrl( url );
      env.setSecurityPrincipal( usr );
      env.setSecurityCredentials( pwd );
      Context ctx = env.getInitialContext();
      MBeanHome adminMBeanHome = (MBeanHome) ctx.lookup( MBeanHome.ADMIN_JNDI_NAME );
      Set srvRuntMBeanSet = adminMBeanHome.getMBeansByType( "ServerRuntime" );
      System.out.println( "Aktive Domain: " + adminMBeanHome.getActiveDomain().getName() +
                        ", Anzahl Server: " + srvRuntMBeanSet.size() );
      System.out.println( "Aktive Server: " );
      Iterator srvRuntMBeanIterator = srvRuntMBeanSet.iterator();
      while( srvRuntMBeanIterator.hasNext() ) {
         ServerRuntimeMBean srvMb = (ServerRuntimeMBean) srvRuntMBeanIterator.next();
         if( srvMb.getState().equals( ServerStates.RUNNING ) ) {
            JTARuntimeMBean jtaMb = srvMb.getJTARuntime();
            JMSRuntimeMBean jmsMb = srvMb.getJMSRuntime();
            System.out.println("  Name: " + srvMb.getName());
            System.out.println("    ListenAddress:                     " + srvMb.getListenAddress());
            System.out.println("    ListenPort:                        " + srvMb.getListenPort());
            System.out.println("    ActivationTime:                    " + srvMb.getActivationTime());
            System.out.println("    HealthState:                       " + srvMb.getHealthState());
            System.out.println("    JTA: ActiveTransactionsTotalCount: " + jtaMb.getActiveTransactionsTotalCount());
            System.out.println("    JTA: TransactionTotalCount:        " + jtaMb.getTransactionTotalCount());
            System.out.println("    JTA: HealthState:                  " + jtaMb.getHealthState());
            System.out.println("    JMS: ConnectionsTotalCount:        " + jmsMb.getConnectionsTotalCount());
            System.out.println("    JMS: JMSServersTotalCount:         " + jmsMb.getJMSServersTotalCount());
            System.out.println("    JMS: HealthState:                  " + jmsMb.getHealthState());
         }
      }
   }
}
